% Matrix Dimensionsionen [10,20,...,1000]
N = 10:10:1000;

% Preallocate memory
error_lu = zeros(length(N),1);
error_qr = zeros(length(N),1);

% Iteration ueber N-Werte
for i=1:length(N)
    % aktuelle Matrix Dimension
    % (A soll als nxn-Matrix definiert werden)
    n = N(i);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Hier matrix A definieren
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % A = ...;

    x = zeros(n,1);
    for j=1:n
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Hier x_j Komponenten definieren
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % x(j) = ...;
    end
    
    % Rechte Seite b mit Loesung x.
    b = A*x;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Loesung mithilfe der LU-Zerlegung
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % ... = lu(A); % <---- LU-Zerlegung
    % y = ...;     % <---- Vorwaertseinsetzen
    % x_lu = ...;  % <---- Rueckwaertseinsetzen

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Berechnung des relativen Fehlers
    % fuer matrix dimension nxn=N(i)xN(i)
    % --- LU - Zerlegung
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % error_lu(i) = ...; % <- rel. Fehler (x vs. x_lu)

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Loesung mithilfe der QR-Zerlegung
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % ... = qr(A); % <---- QR-Zerlegung
    % x_qr = ...;  % <---- Fuer x loesen

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Berechnung des relativen Fehlers
    % fuer matrix dimension nxn=N(i)xN(i)
    % --- QR - Zerlegung
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % error_qr(i) = ...;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot der relativen Fehler
% von LU- und QR-Zerlegung
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Subplot fuer LU-Zerlegung
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subplot(2,1,1)
% plot(...) % <--------- Hier plotten!
title('Fehler fur die LU-Zerlegung')
xlabel('$$n$$','interpreter','latex')
ylabel('$$\frac{\|x_{lu}(n)-x\|_{2}}{\|x\|_{2}}$$','interpreter','latex')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Subplot fuer QR-Zerlegung
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subplot(2,1,2)
% plot(...) % <--------- Hier plotten!
title('Fehler fur die QR-Zerlegung')
xlabel('$$n$$','interpreter','latex')
ylabel('$$\frac{\|x_{qr}(n)-x\|_{2}}{\|x\|_{2}}$$','interpreter','latex')


